#ifndef _H_08355E2FDD6D8D976F470BF9553FC06E_ControlDiagnostic_DCPS_H_
#define _H_08355E2FDD6D8D976F470BF9553FC06E_ControlDiagnostic_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ControlDiagnostic_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ControlDiagnostic_TypeSupportInterface;

            typedef ControlDiagnostic_TypeSupportInterface * ControlDiagnostic_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ControlDiagnostic_TypeSupportInterface> ControlDiagnostic_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ControlDiagnostic_TypeSupportInterface> ControlDiagnostic_TypeSupportInterface_out;


            class ControlDiagnostic_DataWriter;

            typedef ControlDiagnostic_DataWriter * ControlDiagnostic_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ControlDiagnostic_DataWriter> ControlDiagnostic_DataWriter_var;
            typedef DDS_DCPSInterface_out < ControlDiagnostic_DataWriter> ControlDiagnostic_DataWriter_out;


            class ControlDiagnostic_DataReader;

            typedef ControlDiagnostic_DataReader * ControlDiagnostic_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ControlDiagnostic_DataReader> ControlDiagnostic_DataReader_var;
            typedef DDS_DCPSInterface_out < ControlDiagnostic_DataReader> ControlDiagnostic_DataReader_out;


            class ControlDiagnostic_DataReaderView;

            typedef ControlDiagnostic_DataReaderView * ControlDiagnostic_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ControlDiagnostic_DataReaderView> ControlDiagnostic_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ControlDiagnostic_DataReaderView> ControlDiagnostic_DataReaderView_out;

            struct ControlDiagnostic_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ControlDiagnostic_, struct ControlDiagnostic_Seq_uniq_> ControlDiagnostic_Seq;
            typedef DDS_DCPSSequence_var < ControlDiagnostic_Seq> ControlDiagnostic_Seq_var;
            typedef DDS_DCPSSequence_out < ControlDiagnostic_Seq> ControlDiagnostic_Seq_out;

            class  ControlDiagnostic_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ControlDiagnostic_TypeSupportInterface_ptr _ptr_type;
                typedef ControlDiagnostic_TypeSupportInterface_var _var_type;

                static ControlDiagnostic_TypeSupportInterface_ptr _duplicate (ControlDiagnostic_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ControlDiagnostic_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ControlDiagnostic_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ControlDiagnostic_TypeSupportInterface () {};
                ~ControlDiagnostic_TypeSupportInterface () {};
            private:
                ControlDiagnostic_TypeSupportInterface (const ControlDiagnostic_TypeSupportInterface &);
                ControlDiagnostic_TypeSupportInterface & operator = (const ControlDiagnostic_TypeSupportInterface &);
            };

            class  ControlDiagnostic_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ControlDiagnostic_DataWriter_ptr _ptr_type;
                typedef ControlDiagnostic_DataWriter_var _var_type;

                static ControlDiagnostic_DataWriter_ptr _duplicate (ControlDiagnostic_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ControlDiagnostic_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ControlDiagnostic_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ControlDiagnostic_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ControlDiagnostic_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ControlDiagnostic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ControlDiagnostic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ControlDiagnostic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ControlDiagnostic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ControlDiagnostic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ControlDiagnostic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ControlDiagnostic_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ControlDiagnostic_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ControlDiagnostic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ControlDiagnostic_& instance_data) = 0;

            protected:
                ControlDiagnostic_DataWriter () {};
                ~ControlDiagnostic_DataWriter () {};
            private:
                ControlDiagnostic_DataWriter (const ControlDiagnostic_DataWriter &);
                ControlDiagnostic_DataWriter & operator = (const ControlDiagnostic_DataWriter &);
            };

            class  ControlDiagnostic_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ControlDiagnostic_DataReader_ptr _ptr_type;
                typedef ControlDiagnostic_DataReader_var _var_type;

                static ControlDiagnostic_DataReader_ptr _duplicate (ControlDiagnostic_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ControlDiagnostic_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ControlDiagnostic_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ControlDiagnostic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ControlDiagnostic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ControlDiagnostic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ControlDiagnostic_& instance) = 0;

            protected:
                ControlDiagnostic_DataReader () {};
                ~ControlDiagnostic_DataReader () {};
            private:
                ControlDiagnostic_DataReader (const ControlDiagnostic_DataReader &);
                ControlDiagnostic_DataReader & operator = (const ControlDiagnostic_DataReader &);
            };

            class  ControlDiagnostic_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ControlDiagnostic_DataReaderView_ptr _ptr_type;
                typedef ControlDiagnostic_DataReaderView_var _var_type;

                static ControlDiagnostic_DataReaderView_ptr _duplicate (ControlDiagnostic_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ControlDiagnostic_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ControlDiagnostic_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ControlDiagnostic_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ControlDiagnostic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ControlDiagnostic_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ControlDiagnostic_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ControlDiagnostic_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ControlDiagnostic_& instance) = 0;

            protected:
                ControlDiagnostic_DataReaderView () {};
                ~ControlDiagnostic_DataReaderView () {};
            private:
                ControlDiagnostic_DataReaderView (const ControlDiagnostic_DataReaderView &);
                ControlDiagnostic_DataReaderView & operator = (const ControlDiagnostic_DataReaderView &);
            };
        }

    }

}

#endif
