#ifndef _H_8C84AA1C71AFCCA2F462A5056080984E_VehicleStateCommand__H_
#define _H_8C84AA1C71AFCCA2F462A5056080984E_VehicleStateCommand__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace VehicleStateCommand_Constants
            {
                const ::DDS::Octet BLINKER_OFF_ = 0;

                const ::DDS::Octet BLINKER_LEFT_ = 1;

                const ::DDS::Octet BLINKER_RIGHT_ = 2;

                const ::DDS::Octet BLINKER_HAZARD_ = 3;

                const ::DDS::Octet HEADLIGHT_OFF_ = 0;

                const ::DDS::Octet HEADLIGHT_ON_ = 1;

                const ::DDS::Octet HEADLIGHT_HIGH_ = 2;

                const ::DDS::Octet WIPER_OFF_ = 0;

                const ::DDS::Octet WIPER_LOW_ = 1;

                const ::DDS::Octet WIPER_HIGH_ = 2;

                const ::DDS::Octet WIPER_CLEAN_ = 3;

                const ::DDS::Octet GEAR_DRIVE_ = 0;

                const ::DDS::Octet GEAR_REVERSE_ = 0;

                const ::DDS::Octet GEAR_PARK_ = 2;

                const ::DDS::Octet GEAR_LOW_ = 3;

                const ::DDS::Octet GEAR_NEUTRAL_ = 4;

            }

            struct  VehicleStateCommand_
            {
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
                ::DDS::Octet blinker_;
                ::DDS::Octet headlight_;
                ::DDS::Octet wiper_;
                ::DDS::Octet gear_;
                ::DDS::Octet mode_;
                ::DDS::Boolean hand_brake_;
                ::DDS::Boolean horn_;
                ::DDS::Boolean autonomous_;
            };

            typedef DDS_DCPSStruct_var<VehicleStateCommand_> VehicleStateCommand__var;
            typedef VehicleStateCommand_& VehicleStateCommand__out;

        }

    }

}

#endif /* _H_8C84AA1C71AFCCA2F462A5056080984E_VehicleStateCommand__H_ */
